var Node, ref$, parent, type, Export, slice$ = [].slice, arrayFrom$ = Array.from || function(x){return slice$.call(x);};
Node = require('./Node');
ref$ = require('./symbols'), parent = ref$.parent, type = ref$.type;
Export = module.exports = Object.create(Node);
Export[type] = 'Export';
Export.init = function(arg$){
  this.local = arg$.local, this.alias = arg$.alias;
};
Export.childrenNames = ['local', 'alias'];
Export.traverseChildren = function(visitor, crossScopeBoundary){
  var ref$;
  visitor(this.local, this, 'local');
  if (this.alias) {
    visitor(this.alias, this, 'alias');
  }
  (ref$ = this.local).traverseChildren.apply(ref$, arguments);
  if (this.alias) {
    return (ref$ = this.alias).traverseChildren.apply(ref$, arguments);
  }
};
Object.defineProperty(Export, 'name', {
  get: function(){
    var ref$;
    return (ref$ = this.alias) != null
      ? ref$
      : this.local;
  },
  configurable: true,
  enumerable: true
});
Object.defineProperty(Export, 'default', {
  get: function(){
    var ref$;
    return ((ref$ = this.alias) != null ? ref$.name : void 8) === 'default';
  },
  configurable: true,
  enumerable: true
});
Export.compile = function(o){
  var alias, inner;
  alias = this.alias
    ? this.alias.name !== 'default'
      ? [" as ", this.alias.compile(o)]
      : [" as default"]
    : [];
  inner = this.local.compile(o);
  return this.toSourceNode({
    parts: ["export { ", inner].concat(arrayFrom$(alias), [" }"])
  });
};
Export.terminator = ';';
Object.defineProperty(Export, 'local', {
  get: function(){
    return this._local;
  },
  set: function(v){
    v[parent] = this;
    this._local = v;
  },
  configurable: true,
  enumerable: true
});
//# sourceMappingURL=livescript/ast/Export.js.map
