var SourceNode, Creatable, importProperties, ref$, parent, type, x$, Node, slice$ = [].slice, arrayFrom$ = Array.from || function(x){return slice$.call(x);};
SourceNode = require('source-map').SourceNode;
Creatable = require('../../components/core').Creatable;
importProperties = require('../../composition').importProperties;
ref$ = require('./symbols'), parent = ref$.parent, type = ref$.type;
x$ = Node = module.exports = Object.create(null);
importProperties(x$, Creatable);
Node[Symbol.hasInstance] = function(){
  return Object.isPrototypeOf.apply(this, arguments);
};
Node[type] = 'Node';
Node.isStatement = function(){
  return false;
};
Node.terminator = '';
Node.childrenNames = [];
Node.unfoldSoak = function(){};
Node.unparen = function(){
  return this;
};
Node.remove = function(){
  var Type;
  if (!this[parent].removeChild) {
    Type = this[parent][type];
    throw Error("You need to implement method " + Type + "::remove-child youreself");
  }
  return this[parent].removeChild(this);
};
Node.ripName = function(it){
  this.name = it;
};
Node.rewriteShorthand = function(o, assign){};
Node.eachChild = function(fn){
  var i$, ref$, len$, name, child;
  for (i$ = 0, len$ = (ref$ = this.childrenNames).length; i$ < len$; ++i$) {
    name = ref$[i$];
    if (child = this[name]) {
      fn(child);
    }
  }
};
Node.getChildren = function(){
  var children;
  children = [];
  this.eachChild(function(it){
    children.push(it);
  });
  return children;
};
Node.replaceChild = function(){
  var type;
  if (type = this[type]) {
    throw Error("You need to implement method " + type + "::replace-child youreself");
  } else {
    throw Error("You need to implement method ::replace-child youreself");
  }
};
Node.replaceWith = function(){
  var nodes, res$, i$, to$, len$, node, ref$;
  res$ = [];
  for (i$ = 0, to$ = arguments.length; i$ < to$; ++i$) {
    res$.push(arguments[i$]);
  }
  nodes = res$;
  if (!this[parent]) {
    throw Error(this[type] + " doesn't have parent");
  }
  if (!this[parent].replaceChild) {
    throw Error(this[parent][type] + " doesn't imlement replace-child method");
  }
  for (i$ = 0, len$ = nodes.length; i$ < len$; ++i$) {
    node = nodes[i$];
    node[parent] = this[parent];
  }
  return (ref$ = this[parent]).replaceChild.apply(ref$, [this].concat(arrayFrom$(nodes)));
};
Node.compile = function(options, level){
  var o, node, code, that, i$, len$, tmp;
  o = import$({}, options);
  if (level != null) {
    o.level = level;
  }
  node = this.unfoldSoak(o) || this;
  if (o.level && node.isStatement()) {
    return node.compileClosure(o);
  }
  code = (node.tab = o.indent, node).compileNode(o);
  if (that = node.temps) {
    for (i$ = 0, len$ = that.length; i$ < len$; ++i$) {
      tmp = that[i$];
      o.scope.free(tmp);
    }
  }
  return code;
};
Node.toSourceNode = function(arg$){
  var parts, ref$, result, e;
  parts = (ref$ = arg$.parts) != null
    ? ref$
    : [];
  try {
    result = new SourceNode(this.line, this.column, null, parts);
    result.displayName = this[type];
    return result;
  } catch (e$) {
    e = e$;
    console.dir(parts);
    throw e;
  }
};
function import$(obj, src){
  var own = {}.hasOwnProperty;
  for (var key in src) if (own.call(src, key)) obj[key] = src[key];
  return obj;
}
//# sourceMappingURL=livescript/ast/Node.js.map
