var Node, ref$, parent, type, Pattern, slice$ = [].slice, arrayFrom$ = Array.from || function(x){return slice$.call(x);};
Node = require('./Node');
ref$ = require('./symbols'), parent = ref$.parent, type = ref$.type;
Pattern = module.exports = Object.create(Node);
Pattern[type] = 'Pattern';
Pattern.init = function(arg$){
  this.items = arg$.items;
};
Pattern.traverseChildren = function(visitor, crossScopeBoundary){
  var i$, ref$, len$, i, item, results$ = [];
  for (i$ = 0, len$ = (ref$ = this.items).length; i$ < len$; ++i$) {
    i = i$;
    item = ref$[i$];
    visitor(item, this, 'items', i);
  }
  for (i$ = 0, len$ = (ref$ = this.items).length; i$ < len$; ++i$) {
    item = ref$[i$];
    results$.push(item.traverseChildren(visitor, crossScopeBoundary));
  }
  return results$;
};
Pattern.compile = function(o){
  var items;
  items = this.items.map(function(it){
    if (it.compileNode) {
      return it.compileNode(o);
    } else {
      if (it.key) {
        return it.key.value + " : " + it.val.value;
      } else {
        return it.val.value + "";
      }
    }
  });
  items = items.join(', ');
  return this.toSourceNode({
    parts: ["{ "].concat(arrayFrom$(items), [" }"])
  });
};
Pattern.terminator = '';
//# sourceMappingURL=livescript/ast/Pattern.js.map
