var assert, sourceMap, livescriptAstTransform, livescript, SourceNode, ref$, parent, type, fs, path, Creatable, importProperties, Assign, Export, Identifier, Import, Literal, Node, ObjectPattern, Pattern, sn, Prototype, Temporary, Variables, x$, TemporarVariable, y$, TemporarAssigment, fixes, flatten, asArray, convertLiteralToString, CascadeRule, ExportRules, ImportRules, OriginalImports, ConvertImports, ExtractNamesFromSource, ExpandObjectImports, ConvertImportsObjectNamesToPatterns, extractNameFromSource, ExpandArrayImports, ExpandArrayExports, EnableDefaultExports, WrapLiteralExports, WrapAnonymousFunctionExports, ExpandObjectExports, SplitAssignExports, InsertExportNodes, AssignParent, AssignFilename, ExpandMetaImport, copySourceLocation, expandEngine, z$, MoveExportsToTop, MoveImportsToTop, secondStageEngine, compiler, exportResolverStage0, exportResolver, z1$, Plugin, slice$ = [].slice, arrayFrom$ = Array.from || function(x){return slice$.call(x);};
assert = require('assert');
sourceMap = require('source-map');
livescriptAstTransform = require('livescript-ast-transform');
livescript = require('livescript');
SourceNode = sourceMap.SourceNode;
ref$ = require('./livescript/ast/symbols'), parent = ref$.parent, type = ref$.type;
fs = require('fs');
path = require('path');
Creatable = require('./components/core/Creatable');
importProperties = require('./composition').importProperties;
Assign = require('./livescript/ast/Assign');
Export = require('./livescript/ast/Export');
Identifier = require('./livescript/ast/Identifier');
Import = require('./livescript/ast/Import');
Literal = require('./livescript/ast/Literal');
Node = require('./livescript/ast/Node');
ObjectPattern = require('./livescript/ast/ObjectPattern');
Pattern = require('./livescript/ast/Pattern');
sn = function(node){
  var parts, res$, i$, to$, result, e;
  node == null && (node = {});
  res$ = [];
  for (i$ = 1, to$ = arguments.length; i$ < to$; ++i$) {
    res$.push(arguments[i$]);
  }
  parts = res$;
  try {
    result = new SourceNode(node.line, node.column, null, parts);
    result.displayName = node[type];
    return result;
  } catch (e$) {
    e = e$;
    console.dir(parts);
    throw e;
  }
};
Prototype = Symbol('prototype');
Temporary = Symbol('scope::temporary');
Variables = Symbol('scope::variables');
x$ = TemporarVariable = Object.create(Node);
importProperties(x$, Creatable);
TemporarVariable[type] = 'TemporarVariable';
TemporarVariable.init = function(arg$){
  this.name = arg$.name, this.isExport = arg$.isExport;
};
TemporarVariable.traverseChildren = function(visitor, crossScopeBoundary){};
TemporarVariable.compile = function(o){
  var ref$;
  this.temporaryName == null && (this.temporaryName = o.scope.temporary(this.name));
  if (this.isExport) {
    if ((ref$ = o.scope) != null) {
      ref$.variables[this.temporaryName + "."] = 'DONT TOUTCH';
    }
  }
  return sn(this, this.temporaryName);
};
y$ = TemporarAssigment = Object.create(Node);
importProperties(y$, Creatable);
TemporarAssigment[type] = 'TemporarAssigment';
TemporarAssigment.init = function(arg$){
  this.left = arg$.left, this.right = arg$.right;
};
TemporarAssigment.traverseChildren = function(visitor, crossScopeBoundary){
  var ref$;
  visitor(this.left, this, 'left');
  visitor(this.right, this, 'right');
  (ref$ = this.left).traverseChildren.apply(ref$, arguments);
  return (ref$ = this.right).traverseChildren.apply(ref$, arguments);
};
TemporarAssigment.compile = function(o){
  return sn(this, this.left.compile(o), ' = ', this.right.compile(o));
};
TemporarAssigment.terminator = ';';
Object.defineProperty(TemporarAssigment, 'left', {
  get: function(){
    return this._left;
  },
  set: function(v){
    v[parent] = this;
    this._left = v;
  },
  configurable: true,
  enumerable: true
});
Object.defineProperty(TemporarAssigment, 'right', {
  get: function(){
    return this._right;
  },
  set: function(v){
    v[parent] = this;
    this._right = v;
  },
  configurable: true,
  enumerable: true
});
fixes = {
  livescript: {
    ast: {
      entries: {
        assignType: function(arg$){
          var className, _class;
          className = arg$[0], _class = arg$[1];
          if (_class.prototype) {
            return _class.prototype[type] = className;
          }
        }
      },
      values: {
        addMethodReplaceWith: function(it){
          if (!(it.prototype || (it.prototype = {})).replaceWith) {
            it.prototype.replaceWith = Node.replaceWith;
          }
          return it;
        },
        addMethodGetChildren: function(Class){
          if (!(Class.prototype || (Class.prototype = {})).getChildren) {
            return Class.prototype.getChildren = Node.getChildren;
          }
        },
        addReplaceChildMethod: function(Class){
          if (Class.prototype.replaceChild == null) {
            if (Class.prototype[type] === 'Block') {
              return Class.prototype.replaceChild = function(child){
                var nodes, res$, i$, to$, idx, ref$, len$, node;
                res$ = [];
                for (i$ = 1, to$ = arguments.length; i$ < to$; ++i$) {
                  res$.push(arguments[i$]);
                }
                nodes = res$;
                idx = this.lines.indexOf(child);
                if (!(idx > -1)) {
                  throw Error("Trying to replace node witch is not child of current node");
                }
                if (!nodes.length) {
                  throw Error("Replace called without nodes");
                }
                (ref$ = this.lines).splice.apply(ref$, [idx, 1].concat(arrayFrom$(nodes)));
                for (i$ = 0, len$ = nodes.length; i$ < len$; ++i$) {
                  node = nodes[i$];
                  node[parent] = this;
                }
                return child;
              };
            } else {
              return Class.prototype.replaceChild = Node.replaceChild;
            }
          }
        },
        addRemoveChildMethod: function(Class){
          if (Class.prototype.removeChild == null) {
            if (Class.prototype[type] === 'Block') {
              return Class.prototype.removeChild = function(child){
                var idx;
                idx = this.lines.indexOf(child);
                if (!(idx > -1)) {
                  throw Error("Trying to replace node witch is not child of current node");
                }
                this.lines.splice(idx, 1);
                return child;
              };
            } else {
              return Class.prototype.removeChild = Node.removeChild;
            }
          }
        }
      }
    }
  }
};
flatten = function(arr){
  var result;
  result = [];
  arr.forEach(function(it){
    if (Array.isArray(it)) {
      return result.push.apply(result, it);
    } else {
      return result.push(it);
    }
  });
  return result;
};
asArray = function(it){
  if (Array.isArray(it)) {
    return it;
  } else {
    return [it];
  }
};
convertLiteralToString = function(it){
  return it.value.substring(1, it.value.length - 1);
};
CascadeRule = {
  append: function(rule){
    if (!rule.name) {
      throw new Error("Adding rule without a name is realy bad practice");
    }
    return this.rules.push(rule);
  }
};
ExportRules = Object.create(CascadeRule);
ExportRules.name = 'Export';
ExportRules.rules = [];
ExportRules.match = function(it){
  var i$, ref$, len$, rule, m, result;
  if (it[type] === 'Export') {
    for (i$ = 0, len$ = (ref$ = this.rules).length; i$ < len$; ++i$) {
      rule = ref$[i$];
      if (m = rule.match(it)) {
        result = {
          rule: rule,
          matched: m
        };
        break;
      }
    }
  }
  return result;
};
ExportRules.replace = function(arg$){
  var rule, matched, replacer;
  rule = arg$.rule, matched = arg$.matched;
  replacer = rule.replace(matched);
  return asArray(replacer);
};
ImportRules = Object.create(CascadeRule);
ImportRules.name = 'Import';
ImportRules.rules = [];
ImportRules.match = function(it){
  var i$, ref$, len$, rule, m, result;
  if (it[type] === Import[type]) {
    for (i$ = 0, len$ = (ref$ = this.rules).length; i$ < len$; ++i$) {
      rule = ref$[i$];
      if (m = rule.match(it)) {
        result = {
          rule: rule,
          matched: m
        };
        break;
      }
    }
  }
  return result;
};
ImportRules.replace = function(arg$){
  var rule, matched, replacer;
  rule = arg$.rule, matched = arg$.matched;
  replacer = rule.replace(matched);
  return asArray(replacer);
};
OriginalImports = Object.create(CascadeRule);
OriginalImports.name = 'Import';
OriginalImports.rules = [];
OriginalImports.match = function(it){
  var i$, ref$, len$, rule, m, result;
  if (it[type] === 'Import' && it.left.value === 'this') {
    for (i$ = 0, len$ = (ref$ = this.rules).length; i$ < len$; ++i$) {
      rule = ref$[i$];
      if (m = rule.match(it)) {
        result = {
          rule: rule,
          matched: m
        };
        break;
      }
    }
  }
  return result;
};
OriginalImports.replace = function(arg$){
  var rule, matched, replacer;
  rule = arg$.rule, matched = arg$.matched;
  replacer = rule.replace(matched);
  return asArray(replacer);
};
ConvertImports = {
  name: 'ConvertImports',
  match: function(it){
    return {
      source: it.right,
      all: it.all
    };
  },
  replace: function(arg$){
    var all, source;
    all = arg$.all, source = arg$.source;
    return Import.create({
      all: all,
      source: source
    });
  }
};
OriginalImports.append(ConvertImports);
ExtractNamesFromSource = {
  name: 'ExtractNamesFromSource',
  match: function(it){
    var value;
    if (!it.names && (value = it.source.value)) {
      return {
        node: it,
        names: path.basename(value.replace(/\'/gi, ''))
      };
    }
  },
  replace: function(arg$){
    var node, names;
    node = arg$.node, names = arg$.names;
    node.names = Identifier.create({
      name: names
    });
    return node;
  }
};
ImportRules.append(ExtractNamesFromSource);
ExpandObjectImports = {
  name: 'ExpandObjectImports',
  match: function(it){
    if (it.source[type] === 'Obj') {
      return it.source.items;
    }
  },
  replace: function(items){
    return items.map(function(it){
      return Import.create({
        names: it.val,
        source: it.key
      });
    });
  }
};
ImportRules.append(ExpandObjectImports);
ConvertImportsObjectNamesToPatterns = {
  name: 'ConvertImportsObjectNamesToPatterns',
  match: function(it){
    var ref$;
    if (((ref$ = it.names) != null ? ref$[type] : void 8) === 'Obj') {
      return {
        items: it.names.items,
        node: it
      };
    }
  },
  replace: function(arg$){
    var node, items;
    node = arg$.node, items = arg$.items;
    node.names = Pattern.create({
      items: items
    });
    return node;
  }
};
ImportRules.append(ConvertImportsObjectNamesToPatterns);
extractNameFromSource = function(it){
  var this$ = this;
  return path.basename(
  function(it){
    return it[it.length - 1];
  }(
  function(it){
    return it.split(path.sep);
  }(
  function(it){
    return it.replace(/'/gi, '');
  }(
  it))));
};
ExpandArrayImports = {
  name: 'ExpandArrayImports',
  match: function(it){
    if (it.source[type] === 'Arr') {
      return it.source.items;
    }
  },
  replace: function(items){
    return items.map(function(it){
      return Import.create({
        names: Identifier.create({
          name: extractNameFromSource(it.value)
        }),
        source: it
      });
    });
  }
};
ImportRules.append(ExpandArrayImports);
ExpandArrayExports = {
  name: 'ExpandArrayExports',
  match: function(it){
    if (it.local[type] === 'Arr') {
      return it.local.items;
    }
  },
  replace: function(items){
    return items.map(function(it){
      return Export.create({
        local: it
      });
    });
  }
};
ExportRules.append(ExpandArrayExports);
EnableDefaultExports = {
  name: 'EnableDefaultExports',
  match: function(it){
    var cascade;
    if ((cascade = it.local)[type] === 'Cascade' && cascade.input[type] === 'Var' && cascade.input.value === '__es-export-default__') {
      return cascade.output.lines[0];
    }
  },
  replace: function(line){
    return Export.create({
      local: line,
      alias: Identifier.create({
        name: 'default'
      })
    });
  }
};
ExportRules.append(EnableDefaultExports);
WrapLiteralExports = {
  name: 'WrapLiteralExports',
  match: function(it){
    var local, Type;
    local = it.local;
    Type = local[type];
    if (Type === 'Literal' || (Type === 'Fun' && local.name == null) || (Type === 'Class' && local.name == null)) {
      return it;
    }
  },
  replace: function(node){
    var tmp, assign;
    tmp = TemporarVariable.create({
      name: 'export',
      isExport: true
    });
    assign = TemporarAssigment.create({
      left: tmp,
      right: node.local
    });
    return [
      assign, Export.create({
        local: assign.left,
        alias: node.alias
      })
    ];
  }
};
ExportRules.append(WrapLiteralExports);
WrapAnonymousFunctionExports = {
  name: 'WrapAnonymousFunctionExports',
  match: function(it){
    var fn;
    if ((fn = it.local)[type] === 'Fun' && fn.name != null) {
      return fn;
    }
  },
  replace: function(fn){
    return [
      fn, Export.create({
        local: Identifier.create({
          name: fn.name
        })
      })
    ];
  }
};
ExportRules.append(WrapAnonymousFunctionExports);
ExpandObjectExports = {
  name: 'ExpandObjectExports',
  match: function(it){
    var object;
    if ((object = it.local)[type] === 'Obj') {
      return object.items;
    }
  },
  replace: function(items){
    return items.map(function(arg$){
      var key, val;
      key = arg$.key, val = arg$.val;
      return Export.create({
        local: val,
        alias: key
      });
    });
  }
};
ExportRules.append(ExpandObjectExports);
SplitAssignExports = {
  name: 'SplitAssignExports',
  match: function(it){
    var assign;
    if ((assign = it.local)[type] === 'Assign') {
      return {
        alias: it.alias,
        assign: assign
      };
    }
  },
  replace: function(arg$){
    var alias, assign, identifier;
    alias = arg$.alias, assign = arg$.assign;
    identifier = Identifier.create({
      name: assign.left.value
    });
    assign.left = identifier;
    return [
      assign, Export.create({
        local: assign.left,
        alias: alias
      })
    ];
  }
};
ExportRules.append(SplitAssignExports);
InsertExportNodes = {
  name: 'InsertExportNodes',
  match: function(node){
    if (node[type] === 'Cascade' && node.input.value === '__es-export__') {
      return node;
    }
  },
  replace: function(cascade){
    var lines;
    lines = cascade.output.lines;
    if (lines.length === 0) {
      throw Error("Empty export at " + cascade.line + ":" + cascade.column);
    }
    return lines.map(function(it){
      return Export.create({
        local: it
      });
    });
  }
};
AssignParent = {
  name: 'AssignParent',
  match: function(node){
    var childrenWithoutParent;
    childrenWithoutParent = node.getChildren().filter(function(it){
      return !(it[parent] != null);
    });
    if (childrenWithoutParent.length) {
      return {
        node: node,
        children: childrenWithoutParent
      };
    }
  },
  replace: function(arg$){
    var node, children, i$, len$, child;
    node = arg$.node, children = arg$.children;
    for (i$ = 0, len$ = children.length; i$ < len$; ++i$) {
      child = children[i$];
      child[parent] = node;
    }
    return node;
  }
};
AssignFilename = {
  name: 'AssignFilename',
  match: function(node){
    if (!node.filename) {
      return node;
    }
  },
  replace: function(node){
    node.filename = node[parent].filename;
    return node;
  }
};
ExpandMetaImport = {
  name: 'ExpandMetaImport',
  match: function(node){
    if (node.all) {
      return node;
    }
  },
  replace: function(node){
    var e;
    try {
      return exportResolver.resolve(convertLiteralToString(node.source), node.filename);
    } catch (e$) {
      e = e$;
      if (e.message.match(/no such file/)) {
        throw Error("Cannot meta-import module " + node.source.value + " at " + node.line + ":" + node.column + " in " + node.filename + "\nProbably mispelled module path");
      }
    }
  }
};
ImportRules.append(ExpandMetaImport);
copySourceLocation = function(source, target){
  var line, column, children, i$, len$, child;
  line = source.line, column = source.column;
  if (line == null) {
    line = 10000000000;
    column = 10000000000;
    children = source.getChildren();
    for (i$ = 0, len$ = children.length; i$ < len$; ++i$) {
      child = children[i$];
      if (child.line) {
        line = Math.min(line, child.line);
      }
      if (child.column) {
        column = Math.min(column, child.column);
      }
    }
  }
  target.line = line;
  target.column = column;
};
expandEngine = {
  appendRule: function(rule){
    if (!rule.name) {
      throw new Error("Adding rule without a name is realy bad practice");
    }
    this.rules.push(rule);
  },
  rules: [],
  process: function(astRoot){
    var changed, toProcess, processing, i$, len$, node, j$, ref$, len1$, rule, m, newNodes, k$, len2$, n;
    changed = false;
    toProcess = [astRoot];
    while (toProcess.length) {
      changed = false;
      processing = toProcess;
      toProcess = [];
      for (i$ = 0, len$ = processing.length; i$ < len$; ++i$) {
        node = processing[i$];
        for (j$ = 0, len1$ = (ref$ = this.rules).length; j$ < len1$; ++j$) {
          rule = ref$[j$];
          if (m = rule.match(node)) {
            newNodes = asArray(rule.replace(m));
            if (!(newNodes.length === 1 && newNodes[0] === node)) {
              for (k$ = 0, len2$ = newNodes.length; k$ < len2$; ++k$) {
                n = newNodes[k$];
                copySourceLocation(node, n);
              }
              node.replaceWith.apply(node, newNodes);
            }
            changed = true;
            break;
          }
        }
      }
      if (changed) {
        toProcess.push(astRoot);
      } else {
        toProcess.push.apply(toProcess, flatten(processing.map(fn$)));
      }
    }
    function fn$(it){
      return it.getChildren();
    }
  }
};
z$ = expandEngine;
z$.appendRule(AssignParent);
z$.appendRule(AssignFilename);
z$.appendRule(InsertExportNodes);
z$.appendRule(ExportRules);
z$.appendRule(OriginalImports);
z$.appendRule(ImportRules);
MoveExportsToTop = {
  process: function(astRoot){
    var exports, walk, i$, len$, _export;
    exports = [];
    walk = function(node, parent, name, index){
      if (node[type] === 'Export') {
        exports.push(node);
      }
    };
    astRoot.traverseChildren(walk);
    for (i$ = 0, len$ = exports.length; i$ < len$; ++i$) {
      _export = exports[i$];
      _export.remove();
    }
    astRoot.exports = exports;
  }
};
MoveImportsToTop = {
  process: function(astRoot){
    var imports, walk, i$, len$, _import;
    imports = [];
    walk = function(node, parent, name, index){
      if (node[type] === Import[type]) {
        imports.push(node);
      }
    };
    astRoot.traverseChildren(walk);
    for (i$ = 0, len$ = imports.length; i$ < len$; ++i$) {
      _import = imports[i$];
      _import.remove();
    }
    astRoot.imports = imports;
  }
};
secondStageEngine = {
  mutators: [MoveExportsToTop, MoveImportsToTop],
  process: function(astRoot){
    var i$, ref$, len$, mutator, results$ = [];
    for (i$ = 0, len$ = (ref$ = this.mutators).length; i$ < len$; ++i$) {
      mutator = ref$[i$];
      results$.push(mutator.process(astRoot));
    }
    return results$;
  }
};
compiler = {
  livescript: null,
  ast: function(code, options){
    var astRoot;
    if (!options.filename) {
      throw Error("One of rules requires options.filename to be set");
    }
    astRoot = this.livescript.ast(code);
    astRoot.filename = options.filename;
    expandEngine.process(astRoot);
    secondStageEngine.process(astRoot);
    return astRoot;
  }
};
exportResolverStage0 = {
  removeRule: function(rule){
    var idx;
    if (idx = this.rules.indexOf(rule)) {
      this.rules.splice(idx, 1);
    }
  },
  appendRule: function(rule){
    if (!rule.name) {
      throw new Error("Adding rule without a name is realy bad practice");
    }
    this.rules.push(rule);
  },
  rules: Array.from(expandEngine.rules),
  process: function(astRoot){
    var changed, toProcess, processing, i$, len$, node, j$, ref$, len1$, rule, m, newNodes, k$, len2$, n;
    changed = false;
    toProcess = [astRoot];
    while (toProcess.length) {
      changed = false;
      processing = toProcess;
      toProcess = [];
      for (i$ = 0, len$ = processing.length; i$ < len$; ++i$) {
        node = processing[i$];
        for (j$ = 0, len1$ = (ref$ = this.rules).length; j$ < len1$; ++j$) {
          rule = ref$[j$];
          if (m = rule.match(node)) {
            newNodes = asArray(rule.replace(m));
            if (!(newNodes.length === 1 && newNodes[0] === node)) {
              for (k$ = 0, len2$ = newNodes.length; k$ < len2$; ++k$) {
                n = newNodes[k$];
                copySourceLocation(node, n);
              }
              node.replaceWith.apply(node, newNodes);
            }
            changed = true;
            break;
          }
        }
      }
      if (changed) {
        toProcess.push(astRoot);
      } else {
        toProcess.push.apply(toProcess, flatten(processing.map(fn$)));
      }
    }
    function fn$(it){
      return it.getChildren();
    }
  }
};
exportResolverStage0.removeRule(ExpandMetaImport);
exportResolver = {
  livescript: null,
  resolve: function(modulePath, currentPath){
    var cwd, resolvedPath, ext, code, astRoot, exports, items;
    cwd = path.dirname(currentPath);
    resolvedPath = path.resolve(cwd, modulePath);
    if (!(modulePath[0] === '.' || modulePath.match(/\.js$/))) {
      throw Error("Only local livescript files can be imported to scope");
    }
    ext = path.extname(path.basename(resolvedPath)).length ? '' : '.ls';
    code = fs.readFileSync(resolvedPath + ext, 'utf8');
    astRoot = this.livescript.ast(code);
    astRoot.filename = resolvedPath;
    exportResolverStage0.process(astRoot);
    secondStageEngine.process(astRoot);
    exports = astRoot.exports;
    items = exports.map(function(it){
      return Identifier.create({
        name: it.name.value
      });
    });
    return Import.create({
      names: ObjectPattern.create({
        items: items
      }),
      source: Literal.create({
        value: "'" + modulePath + "'"
      })
    });
  }
};
z1$ = Plugin = Object.create(livescriptAstTransform);
module.exports = z1$;
z1$.name = 'transform-es-modules';
z1$.enable = function(){
  var originalTokenize, Block, originalCompileRoot, Self, k, ref$, v, i$, ref1$, fix, Nodelivescript, originalCompileWithDeclarations, scopePatched, own$ = {}.hasOwnProperty;
  originalTokenize = this.livescript.lexer.tokenize;
  exportResolver.livescript = this.livescript;
  this.livescript.lexer.tokenize = function(){
    var result, lexed, i, buffer, l, rest, ref$;
    result = [];
    lexed = originalTokenize.apply(this, arguments);
    i = -1;
    buffer = [lexed[0], lexed[1]];
    while (++i < lexed.length) {
      l = lexed[i];
      rest = slice$.call(l, 2);
      if (l[0] === 'DECL' && l[1] === 'export') {
        result.push(['ID', '__es-export__'].concat(arrayFrom$(rest)));
        if (i + 2 < lexed.length && lexed[i + 2][0] === 'DEFAULT') {
          result.push(lexed[++i]);
          ++i;
          ref$ = l = lexed[i], rest = slice$.call(ref$, 2);
          result.push(['ID', '__es-export-default__'].concat(arrayFrom$(rest)));
        }
      } else {
        result.push(l);
      }
    }
    return result;
  };
  Block = this.livescript.ast.Block;
  originalCompileRoot = Block.prototype.compileRoot;
  Self = this;
  for (k in ref$ = this.livescript.ast) if (own$.call(ref$, k)) {
    v = ref$[k];
    for (i$ in ref1$ = fixes.livescript.ast.entries) if (own$.call(ref1$, i$)) {
      fix = ref1$[i$];
      fix([k, v]);
    }
    for (i$ in ref1$ = fixes.livescript.ast.values) if (own$.call(ref1$, i$)) {
      fix = ref1$[i$];
      fix(v);
    }
  }
  Nodelivescript = this.livescript;
  Block.prototype.compileRoot = function(o){
    var astRoot, result, nonDefaultExports, exports, imports, getVariableName, exportsDeclaration;
    astRoot = this;
    astRoot.filename = o.filename;
    expandEngine.process(astRoot);
    secondStageEngine.process(astRoot);
    result = originalCompileRoot.apply(this, arguments);
    nonDefaultExports = astRoot.exports;
    exports = astRoot.exports.map(function(it){
      return sn(it, it.compile(o), '\n');
    });
    imports = astRoot.imports.map(function(it){
      return sn(it, it.compile(o), '\n');
    });
    getVariableName = function(it){
      return it.local.compile({});
    };
    exportsDeclaration = nonDefaultExports.length ? "var " + nonDefaultExports.map(getVariableName).join(',') + ";\n" : "";
    return sn.apply(null, [astRoot].concat(arrayFrom$(imports), [exportsDeclaration], arrayFrom$(exports), [result]));
  };
  originalCompileWithDeclarations = Block.prototype.compileWithDeclarations;
  scopePatched = false;
};
z1$.disable = function(){
  this.livescript.ast.Fun.prototype.compile = this.originalCompile;
};
//# sourceMappingURL=plugin.js.map
